#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

typedef int (*pPrinterCreator)(void** handle,const char* );

typedef int (*pPrinterDestroy)(void* handle);

typedef int (*pPortOpen)(void* handle,const char* );

typedef int (*pFormatError)(int errorNO,int ,unsigned char*,int,int);

typedef int (*pPortClose)(void* handle);

typedef int( *pDirectIO)(void* handle, unsigned char writedata[], unsigned int writenum, unsigned char readdata[], unsigned int readnum, unsigned int* preadednum);

typedef int( *pCPCL_AddLabel)(void* , int , int , int );

typedef int( *pCPCL_SetAlign)(void* , int );

typedef int( *pCPCL_AddText)(void* , int , const char*, int,int , int , int , const char*);

typedef int( *pCPCL_AddBarCode)(void* , int , int , int , int , int , int , int , const char* );

typedef int( *pCPCL_AddBarCodeText)(void* , int , int , int , int );

typedef int( *pCPCL_AddQRCode)(void* , int , int , int , int , int , int , const char* );

typedef int( *pCPCL_AddPDF417)(void* , int , int , int , int , int , int , int , int , const char* );

typedef int( *pCPCL_AddBox)(void* , int , int , int , int , int );

typedef int( *pCPCL_AddLine)(void* , int , int , int , int , int );

typedef int( *pCPCL_SetFontSize)(void* , int , int );

typedef int( *pCPCL_SetDensity)(void* , int );

typedef int( *pCPCL_SetSpeed)(void* , int );

typedef int( *pCPCL_SetTextSpacing)(void* , int );

typedef int( *pCPCL_SetTextBold)(void* , int );

typedef int( *pCPCL_SetTextUnderline)(void* , int );

typedef int( *pCPCL_Print)(void*);

typedef int( *pCPCL_NextLabelPos)(void* );

typedef int( *pCPCL_PreFeed)(void* , int );

typedef int( *pCPCL_PostFeed)(void* , int );


void Test_cpcl()
{	

	void *phandle = NULL;
 	int status = 0; 
	int result = 0;
	char error_msg[1024] = {0};
	void* handle = dlopen("./libcpcl_sdk.so",RTLD_LAZY);
	if(!handle)
	{
		printf("Failed to load shared library.\r\n");
		return; 	
	}
	else
	{
		printf("Load successed.\r\n");
	}

	pPrinterCreator PrinterCreator = (pPrinterCreator)dlsym(handle,"PrinterCreator");
	pPrinterDestroy PrinterDestroy = (pPrinterDestroy)dlsym(handle,"PrinterDestroy");
	pPortOpen PortOpen = (pPortOpen)dlsym(handle,"PortOpen");
	pPortClose PortClose = (pPortClose)dlsym(handle,"PortClose");
	pFormatError FormatError = (pFormatError)dlsym(handle,"FormatError");

	pDirectIO DirectIO = (pDirectIO)dlsym(handle,"DirectIO");
	pCPCL_AddLabel CPCL_AddLabel = (pCPCL_AddLabel)dlsym(handle,"CPCL_AddLabel");
	pCPCL_SetAlign CPCL_SetAlign = (pCPCL_SetAlign)dlsym(handle,"CPCL_SetAlign");

	pCPCL_AddText CPCL_AddText = (pCPCL_AddText)dlsym(handle,"CPCL_AddText");
	pCPCL_AddBarCode CPCL_AddBarCode = (pCPCL_AddBarCode)dlsym(handle,"CPCL_AddBarCode");
	pCPCL_AddBarCodeText CPCL_AddBarCodeText = (pCPCL_AddBarCodeText)dlsym(handle,"CPCL_AddBarCodeText");
	pCPCL_AddQRCode CPCL_AddQRCode = (pCPCL_AddQRCode)dlsym(handle,"CPCL_AddQRCode");
	pCPCL_AddPDF417 CPCL_AddPDF417 = (pCPCL_AddPDF417)dlsym(handle,"CPCL_AddPDF417");
	pCPCL_AddBox CPCL_AddBox = (pCPCL_AddBox)dlsym(handle,"CPCL_AddBox");
	pCPCL_AddLine CPCL_AddLine = (pCPCL_AddLine)dlsym(handle,"CPCL_AddLine");
	pCPCL_SetFontSize CPCL_SetFontSize = (pCPCL_SetFontSize)dlsym(handle,"CPCL_SetFontSize");
	pCPCL_SetDensity CPCL_SetDensity = (pCPCL_SetDensity)dlsym(handle,"CPCL_SetDensity");
	pCPCL_SetSpeed CPCL_SetSpeed = (pCPCL_SetSpeed)dlsym(handle,"CPCL_SetSpeed");

	pCPCL_SetTextSpacing CPCL_SetTextSpacing = (pCPCL_SetTextSpacing)dlsym(handle,"CPCL_SetTextSpacing");
	pCPCL_SetTextBold CPCL_SetTextBold = (pCPCL_SetTextBold)dlsym(handle,"CPCL_SetTextBold");

	pCPCL_Print CPCL_Print = (pCPCL_Print)dlsym(handle,"CPCL_Print");
	pCPCL_NextLabelPos CPCL_NextLabelPos = (pCPCL_NextLabelPos)dlsym(handle,"CPCL_NextLabelPos");


	pCPCL_PreFeed CPCL_PreFeed = (pCPCL_PreFeed)dlsym(handle,"CPCL_PreFeed");
	pCPCL_PostFeed CPCL_PostFeed = (pCPCL_PostFeed)dlsym(handle,"CPCL_PostFeed");

	result = PrinterCreator(&phandle, "HM-T300PRO");
	if (0 != result)
	{
	  FormatError(result, 0, (unsigned char*)error_msg, 0, sizeof(error_msg));
	  printf("Creation fail:%s\n", error_msg);
       	  return;
  	}
	else
	{
		printf("Creation successed\r\n");
	}

	result = PortOpen(phandle, "USB,iT4E,vid=0x20D1,pid=0x4000");//based on device change libzpl_sdk.so
	//result = PortOpen(phandle, "COM,ttyUSB0,BAUDRATE=115200");
	//result = PortOpen(phandle, "NET,192.168.1.1");
	printf("PortOpen result= %d\r\n",result);
	
	if (0 != result)
	{
	  FormatError(result, 0, (unsigned char*)error_msg, 0, sizeof(error_msg));
	  printf("%s\n", error_msg);
	}
	else
	{
	  	//printf("Open successed\n");
	
	  	result = CPCL_AddLabel(phandle, 0, 1100, 1);

		//result = CPCL_AddText(hprinter, 0,_T(""), 7, 2, 10, 10, _T(""));
		result = CPCL_AddText(phandle, 0, (""),7, 2, 90, 10, ("hello"));

		result = CPCL_AddBarCodeText(phandle, 1, 7, 0, 5);

		result = CPCL_AddBarCode(phandle, 0, 0, 1, 1, 50, 10, 80, ("123456789"));

		result = CPCL_AddBarCode(phandle, 0, 5, 1, 1, 50, 10, 180, ("66886868"));

		result = CPCL_AddBarCode(phandle, 0, 7, 1, 1, 50, 10, 280, ("88886666"));

		result = CPCL_AddBarCode(phandle, 0, 10, 1, 1, 50, 10, 380, ("012345678901"));

		result = CPCL_AddBarCode(phandle, 0, 13, 1, 1, 50, 10, 480, ("1234567"));

		result = CPCL_AddQRCode(phandle, 0, 10, 580, 2, 6, 1, ("1010011110"));

		result = CPCL_AddPDF417(phandle, 0, 10, 750, 2, 6, 8, 8, 1, ("0010101101"));

		result = CPCL_AddBox(phandle, 10, 820, 40, 880, 3);

		result = CPCL_AddLine(phandle, 10, 900, 80, 970, 3);

		result = CPCL_SetDensity(phandle, 3);

		result = CPCL_Print(phandle);

		result = PortClose(phandle);

		result = PrinterDestroy(phandle);

	}
	if(!result)
	{
		printf("CPCLTest success");	
	}
	else
	{       
		printf("CPCLest fail");
	}
	
}


int main()
{
    Test_cpcl();
    return 0;
}
